// SelfTestResults.cpp : implementation file
//

#include "stdafx.h"
#include "tulsa sample app.h"
#include "SelfTestResults.h"
#include <IStbTulsaCtl.h>
#include "Tulsa Sample AppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelfTestResults dialog


CSelfTestResults::CSelfTestResults(int CardNumber, CWnd* pParent /*=NULL*/)
	: CDialog(CSelfTestResults::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelfTestResults)
	m_bSelfTestComplete = FALSE;
	m_AudCDTest0 = _T("");
	m_MemTest0 = _T("");
	m_RegTest0 = _T("");
	m_VidCDTest0 = _T("");
	m_VidIntTest0 = _T("");
	//}}AFX_DATA_INIT

	m_CardNumber = CardNumber;
}


void CSelfTestResults::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelfTestResults)
	DDX_Check(pDX, IDC_COMPLETE, m_bSelfTestComplete);
	DDX_Text(pDX, IDC_AUDCD_TEST0, m_AudCDTest0);
	DDX_Text(pDX, IDC_MEM_TEST0, m_MemTest0);
	DDX_Text(pDX, IDC_REG_TEST0, m_RegTest0);
	DDX_Text(pDX, IDC_VIDCD_TEST0, m_VidCDTest0);
	DDX_Text(pDX, IDC_VIDINT_TEST0, m_VidIntTest0);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelfTestResults, CDialog)
	//{{AFX_MSG_MAP(CSelfTestResults)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelfTestResults message handlers

#define GET_RESULT_STR(bPassed)	(bPassed? "Ok": "Bad");

BOOL CSelfTestResults::OnInitDialog() 
{
	CDialog::OnInitDialog();

	ShowResults();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSelfTestResults::ShowResults()
{
	TULSA_RESULT result;
	TULSA_TEST_STATUS DiagStatus;
	CTulsaSampleAppView *pView = (CTulsaSampleAppView*)(((CFrameWnd *)AfxGetMainWnd())->GetActiveView());
	CCardDlg* pDlg;
	if (pDlg = pView->GetCardDialog(pView->GetCurrentCard()))
	{
		result = pDlg->pBoardControl->GetSelfTestResults(&DiagStatus);
	}
	m_bSelfTestComplete = DiagStatus.bDiagsFinished;

	if (!m_bSelfTestComplete) {
		UpdateData(FALSE);
		return;
	}

	m_RegTest0 = GET_RESULT_STR(DiagStatus.ChanStatus.bAVDecoderRegTestPassed);
	if (DiagStatus.ChanStatus.bAVDecoderRegTestPassed) {
		m_MemTest0 = GET_RESULT_STR(DiagStatus.ChanStatus.bAVDecoderMemTestPassed);
		m_VidCDTest0 = GET_RESULT_STR(DiagStatus.ChanStatus.bAVDecoderVidCDTestPassed);
		m_AudCDTest0 = GET_RESULT_STR(DiagStatus.ChanStatus.bAVDecoderAudCDTestPassed);
		m_VidIntTest0 = GET_RESULT_STR(DiagStatus.ChanStatus.bAVDecoderVidIntTestPassed);		
	} else {
		m_MemTest0 = "?";
		m_VidCDTest0 = "?";
		m_AudCDTest0 = "?";
		m_VidIntTest0 = "?";
	}

	UpdateData(FALSE);

}


void CSelfTestResults::OnRefresh() 
{
	ShowResults();	
}
